package action

import (
	"fmt"
	"go.mongodb.org/mongo-driver/bson"
	"math/rand"
	"pro2d/common"
	"pro2d/common/db/mongoproxy"
	"pro2d/common/db/redisproxy"
	"pro2d/common/logger"
	"testing"
)

func TestGetActionMap(t *testing.T) {
	rand.Seed(common.Timex())

	var redisConf = common.GlobalSconf.RedisConf
	if err := redisproxy.ConnectRedis(redisConf.DB, redisConf.Auth, redisConf.Address); err != nil {
		logger.Error(err)
		return
	}
	name := getRandomName()
	fmt.Println(name)
}

func TestEquipmentDelRpc(t *testing.T) {
	err := mongoproxy.ConnectMongo(common.GlobalConf.GameConf.MongoConf, common.GlobalConf.GameConf.ID)
	if err != nil {
		logger.Error(err)
		return
	}

	filter := bson.D{{"id", bson.D{{"$in", bson.A{"10000020021", "10000020037"}}}}}
	if err := mongoproxy.DelMany("equipment", filter); err != nil {
		logger.Error(err.Error())
	}
}
